#include <stdio.h>
#include <stdbool.h>
#include <string.h>

#include <logs_text2.h>
#include <log_it.h>

/*
 * It is more or less "grep -v string file >to_file"
 * 	But:	Some logentrys have more than one line, but they have the same time (snort)
 * 	So it buffers every logentry, and compares the time with the last one.
 * 	If it matches, it belongs to the same log, and it's buffered
 *  
 *  Return:
 *  On sucess: 	number of lines that are removed now
 *  Error:
 *  	-1	No file string
 *  	-2	No target file string
 *  	-3	No string to search
 *  	-4	Cannot open file
 *  	-5	Cannot open target file
 *  	-6	Cannot open logfile
 */

int remove_logs(const char *file,
                const char *to_file,
		          const char *string,
		          int verbose, 
                const char *logfile, 
                const char *key)
{
   FILE *f_read, *f_write, *f_log;
   char buffer1[BUFFER + 1] = { '\0' };
   char buffer2[BUFFER + 1] = { '\0' };
   char check1[TIMEBUFFER + 1] = { '\0' };
   char check2[TIMEBUFFER + 1] = { '\0' };
   char CheckBuffer[BUFFER_FOR_LINES][BUFFER];
   char *get_time, *grep;
   int lines_removed = 0;
   int lines_written = 0;
   int lines_org = 0;
   bool found = false;
   int a = 0, b = 0, i = 0, j = 0;
   
   /* Idiot checking (newer trust programmers!) */
   if(!file) {
	   fprintf(stderr, "[ERROR] No file to clean!\n");
	   return -1;
   }
   if(!to_file) {
	   fprintf(stderr, "[ERROR] No file to write to!\n");
	   return -2;
   }
   if(!string) {
	   fprintf(stderr, "[ERROR] No string for cleaning!\n");
	   return -3;
   }

   /* give status message */
   if(verbose > 2) {
	   printf("[STATUS]	grep -v %s in %s\n", string, file);
   }
   
   /* Open all files */
   if((f_read = fopen(file, "r")) == 0) {
	   fprintf(stderr, "[ERROR] in read opening %s\n", file);
	   perror("[ERROR] replace_in_file(): ");
	   return -4;
   }
   if((f_write = fopen(to_file, "w")) == 0) {
	   fprintf(stderr, "[ERROR] in write opening %s\n", to_file);
	   perror("[ERROR] replace_in_file(): ");
	   return -5;
   }
   if(logfile) {
	   if((f_log = fopen(logfile, "w")) == 0) {
	      fprintf(stderr, "[ERROR] in write opening %s\n", logfile);
	      perror("[ERROR] replace_in_file(): ");
	      return -6;
	   }
   }
   
   /*  clear the buffer again */
   for(j = 0; j < BUFFER_FOR_LINES; j++) {
	   memset(CheckBuffer[j], 0, BUFFER);
   }
   
   /* Ok let's start */
   while (!feof(f_read)) {	/* reading file */
	   /* reset */
	   memset(buffer1, 0, BUFFER);
	   memset(check1, 0, TIMEBUFFER);
	   fgets(buffer1, BUFFER, f_read);
	   lines_org++;
	   get_time = 0;
	   grep = 0;
	   a = 0;
	   
      /* this is not a logentry, so ignore it */
	   if(strlen(buffer1) < 1) {
	      break;
	   }
	   
      /* save buffer */
	   memcpy(buffer2, buffer1, BUFFER);
      buffer2[BUFFER] = 0x0; /*  */

	   /* now let's save the time of the logentry
       * Some logfiles in /var/log are not "normal" logfiles,
	    * but usually you can ignore them
	    *
	    * Examples:
	    *    /var/log/emerge.log
	    *	   /var/log/Xorg.0.log
	    */
	   get_time = strtok(buffer2, " ");
	   if(get_time == 0) {
	      if(verbose >3 ) {
	    	   fprintf(stderr,"[ERROR] This seems NOT to be a logentry!\
                    Ignore IT\n");
	    	   if(verbose >5 ) {
			      printf("Ignoring |%s|", buffer1);
		      }
	      }
	      break;
	   }
	   a = strlen(get_time) + 2;
	   
      if(a < TIMEBUFFER) {
         strncat(check1, get_time, sizeof(check1) - strlen(check1) - 1); 
	      strncat(check1, " ", sizeof(check1) - strlen(check1) - 1);
	   } else {
         if (verbose >6 ) {
	         fprintf(stderr,"[ERROR] Awoid Buffer0verflow -> Ignore Line\n");
	         printf("|%s|", buffer1);
         }
	      break;
	   }
	   for(b = 0; b < 3; b++) {
	      get_time = strtok(0, " ");
	         if(get_time == 0) {
		         if(verbose >3 ) {    
			         fprintf(stderr,"[ERROR] This seems NOT to be a logentry!\
                          Ignore IT..\n");
			         if(verbose >5 ) {
				         printf("Ignoring |%s|", buffer1);
			         }
		         }
		         break;
	         }
	         a = a + strlen(get_time) + 2;
	         if(a < TIMEBUFFER) {
		         strncat(check1, get_time, sizeof(check1) - strlen(check1) - 1);
		         strncat(check1, " ", sizeof(check1) - strlen(check1) - 1);
	         } else {
               if (verbose >6 ) {
		            fprintf(stderr,"[ERROR] Awoid Buffer0verflow -> Ignore Line\n");
		            printf("%s", buffer1);
               }
		         break;
	         }
	   }
	   
      /* now check if the last time string == time string */
	   if((strcmp(check1, check2)) == 0) {
         ; /* go on */
	   } else {
	      if(found == true) {	/* it matches string */
		      if(verbose > 2) {
		         printf("[INFO] Removing %d Lines\n", i);
		      }
		      if(verbose > 4) {
		         for(j = 0; j <= i; j++) {
			         printf("[FOUND]\t %s", CheckBuffer[j]);
		         }
		      }
		      if(logfile) {
		         for(j = 0; j <= i; j++) {
			         if(key) {
			            crypt_log_it(logfile, key, "[FOUND]\t %s",
					      CheckBuffer[j]);
			         } else {
			            log_it(logfile, "[FOUND]\t %s",
				         CheckBuffer[j]);
			         }
		         }
		      }
		      found = false;
	         } else {	/* entry is clean, so it can be written to file */
		         for(j = 0; j <= i; j++) {
		            fprintf(f_write, "%s", CheckBuffer[j]);
		         }
		      lines_written = lines_written + i;
	   }
         
	   /* clear the buffer again */
	   for(j = 0; j <= i; j++) {
		   memset(CheckBuffer[j], 0, BUFFER);
	   }

	   /* reset counter */
	   i = 0;
	}

   /* save in buffer */
	if(i < BUFFER_FOR_LINES) {
      memcpy(CheckBuffer[i], buffer1, BUFFER); /*  */
      CheckBuffer[i][BUFFER - 1] = 0x0;       
	   i++;
	} else {
      /*
		 * Sometimes kernel booting messages have many many lines,
		 * but this is usually not important to check
		 * sometimes postfix, and the statistics of snort during 
		 * starting and stopping snort
		 * TODO:
		 *  write all of them (malloc) 
		 */
	    if(verbose >2) {
          fprintf(stderr, "[ERROR] \ttoo many lines\t Ignore!\n");
	    }
	    if(verbose >5) {
          for(j= 0; j <= i; j++) {
             printf("[ERROR] Ignoring\t %s", CheckBuffer[j]);
			 }
	    }
	}
   
	/* save time */
	memcpy(check2, check1, TIMEBUFFER);
   check2[sizeof(check2) - 1] = 0x0; /*  */

	/* grep for string */
	grep = strstr(buffer1, string);
	if(grep != 0) {	/* found */
	   found = true;
	}
 }	/* end reading file */

   /* don't forget the rest */
   if(found == false) {	/* rest is clean, so write it to file */
	   for(j = 0; j <= i; j++) {
	      fprintf(f_write, "%s", CheckBuffer[j]);
	      lines_written++;
	   }
	   
      /*lines_written++; */
   } else {			/* it matches string */
	   if(verbose > 3) {
	      printf("[INFO] Removing %d Lines\n", i);
	   }
	   if(verbose > 4) {
	      for(j = 0; j <= i; j++) {
		      printf("[FOUND]\t %s", CheckBuffer[j]);
	      }
	   }
	   if(logfile) {
	      for(j = 0; j <= i; j++) {
		      if(key) {
		         crypt_log_it(logfile, key, "[FOUND]\t %s",
				   CheckBuffer[j]);
		      } else {
		         log_it(logfile, "[FOUND]\t %s", CheckBuffer[j]);
		      }
	      }
	   }
   }

   /* Closing files again */
   /* no, there some bug at the moment, later...*/
   /* if (f_log != 0) {
	 *    fclose(f_log);
    * } 
    */
    fclose(f_write);
    fclose(f_read);

    /* calculate statistic */
    lines_org--;
    lines_written--;

    lines_removed = lines_org - lines_written;
      
    if(verbose > 2) {
       printf("[STATUS] From %d lines %d lines written -> %d lines removed\n",
              lines_org, lines_written, lines_removed);
    }
    
    return(lines_removed);
}
