#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <utils_wipe.h>
#include <utils_copy.h>

/* simple copy file funktion with wiping and overwriting target file:
 *    -1 error in open read file
 *		-2 error in open write file
 *		-3 error in wiping write file
 */
int writeBack(char *from, char *to, int verbose)
{
   register int a;
   int IN, OUT;
   char buff[CP_BUFFER];
   struct stat perm;

   /* if target don't exist, create it */
   if(stat(to, &perm) != 0) {
	   if((OUT = open(to, O_WRONLY | O_TRUNC | O_CREAT, S_IWUSR | S_IRUSR)) 
         == -1) {
	         fprintf(stderr, "[ERROR] cannot open O_WRONLY |O_TRUNC %s !\n", to);
	         perror("[ERROR] in writeBack: opening to ");
	         return -2;
	   }
	   close(OUT);
   } else {
	   /* WIPE_MILITARY should be ok here */
	   if(shred(to, verbose, WIPE_MILITARY) != 0) {
         fprintf(stderr, "[ERROR] wipe_file(%s)\n", to);
         return -3;
	   }
   }

   /* Idiot checking 
    * TODO: 
    *  Idiot fixing, use O_CREAT and write perms back
    *  but this is BAD!!!
    *   (Microsoft Style) 
    */
   if(stat(to, &perm) != 0) {
      fprintf(stderr,"[ERROR] Idiot! You have to modify wipe_file.c\
              NOT to unlink to file\n");
   }
   if((IN = open(from, O_RDONLY)) == -1) {
	   fprintf(stderr, "[ERROR] cannot open O_RDONLY %s !\n", from);
	   return -1;
   }

   /* hmm, O_CREAT should NOT be necessary, 
    * but it IS if wipe_file deletes it 
    */
   if((OUT = open(to, O_WRONLY | O_TRUNC | O_CREAT)) == -1) {
	   fprintf(stderr, "[ERROR] cannot open O_WRONLY |O_TRUNC %s !\n", to);
	   perror("[ERROR] in writeBack: opening to ");
	   return -2;
   }
   while((a = read(IN, buff, CP_BUFFER)) > 0) {
	   write(OUT, buff, a);
   }
   close(IN);
   close(OUT);

   return (0);
}
