#include <stdio.h>
#include <unistd.h>

#include "../ncrypt/wipe_file.h"
#include <utils_wipe.h>

/*
 * secure overwriting of a file
 *  return:	  0 on sucess
 *  		 -1 wrong option
 *  		 -2 cannot overwrite file
 */
int shred(char *file, int verbose, int mode)
{
   int wipeverbose = 0;

   /* wipe verbose? */
   if (verbose > 3) {
      wipeverbose = 1;
   } else {
	   wipeverbose = 0;
   }
   
   if ((mode < 1) || (mode > 3)) {
      fprintf(stderr, "[ERROR] wrong mode(%d) to wipe %s\n", mode, file);
	   return -1;
   }
   if(wipe_file(file, wipeverbose, mode) != 0) {
	   fprintf(stderr, "[ERROR] wipe_file(%s)\n", file);
	   return -2;
   }
   
   return 0;
}

/*
 *  delete a file secure
 *  return:
 *    0  on sucess
 *  	-2 error in overwriting
 *  	-3 error in unlinking file
*/
int wipe(char *file, int verbose)
{
   int ret = 0;
   
   if(shred(file, verbose, WIPE_BOTH) < 0) {
	   fprintf(stderr, "[ERROR] shred(%s)\n", file);
	   ret = -2;
   }
   if(unlink(file) != 0) {
	   fprintf(stderr, "[ERROR] unlink(%s)\n", file);
	   ret = -3;
   }

   return (ret);
}
