#include <stdio.h>
#include <string.h>

/* own */
#include <logcl.h>
#include <misc_add.h>
#include <misc_dirs.h>
#include <default_paths.h>
#include <defaults_add.h>

/*
 * Trys to add all logfiles defined by default.
 * If this file don't exists, it will be ignored
 */
void add_default_logs(block_head_t * mylog, struct Cleanme *MyLog)
{
   int a;

   if(MyLog->verbose > 3) {
	   printf("[VERBOSE] Adding default logfiles \n");
   }
   
   /* UTMP */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding utmp\n");
   } 
   MyLog->logtype = 3;
   
   for(a = 0; logPaths_utmp[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
	      printf(" %s, ", logPaths_utmp[a]);
      }
	   memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logPaths_utmp[a], BUFF_LONG - 1);
	   addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   
   /* WTMP */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding wtmp\n");
   } 
   MyLog->logtype = 3;
   
   for(a = 0; logPaths_wtmp[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
	      printf(" %s, ", logPaths_wtmp[a]);
	   }
      memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logPaths_wtmp[a], BUFF_LONG - 1);
	   addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
         /* WTMPX */
         if(MyLog->verbose > 4) {
	         printf("[VERBOSE] Adding wtmx\n");
         }
   } 
   MyLog->logtype = 4;
   
   for(a = 0; logPaths_wtmpx[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
	      printf(" %s, ", logPaths_wtmpx[a]);
      }
	   memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logPaths_wtmpx[a], BUFF_LONG - 1);
	   addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   
   /* UTMPX */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding utmpx\n");
   }
   MyLog->logtype = 4;
   
   for(a = 0; logPaths_utmpx[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
         printf(" %s, ", logPaths_utmpx[a]);
	      memset(MyLog->name, 0, BUFF_LONG);
	      strncpy(MyLog->name, logPaths_utmpx[a], BUFF_LONG - 1);
	      addLog(mylog, MyLog);
      }
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* LASTLOG */
   if(MyLog->verbose > 4) {
      printf("[VERBOSE] Adding lastlog\n");
   }
   MyLog->logtype = 5;
   
   for(a = 0; logPaths_lastlog[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
         printf(" %s, ", logPaths_lastlog[a]);
      }
	   memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logPaths_lastlog[a], BUFF_LONG - 1);
	   addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   /* ACCT */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding accounting\n");
   } 
   MyLog->logtype = 6;
   
   for(a = 0; logPaths_acct[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
	      printf(" %s, ", logPaths_acct[a]);
      }
	   memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logPaths_acct[a], BUFF_LONG - 1);
	   addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   /* MOD_SECURITY */
   if(MyLog->verbose > 4){
      printf("[VERBOSE] Adding audit_logs logfiles\n");
   }
   MyLog->logtype = 8;

   for(a = 0; logPaths_modsec[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_modsec[a]);
      }
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_modsec[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* PRELUDE.LOG */
   if(MyLog->verbose > 4){
      printf("[VERBOSE] Adding prelude logfiles\n");
   }
   MyLog->logtype = 9;
   
   for(a = 0; logPaths_prelude_log[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_prelude_log[a]);
      }  
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_prelude_log[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* PRELUDE-XML.LOG */
   if(MyLog->verbose > 4){
      printf("[VERBOSE] Adding prelude-xml logfiles\n");
   }
   MyLog->logtype = 10;
   
   for(a = 0; logPaths_prelude_xml[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_prelude_xml[a]);
      }
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_prelude_xml[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* SAMBA_LOG */
   if(MyLog->verbose > 4){
      printf("[VERBOSE] Adding Samba logfiles\n");
   }
   MyLog->logtype = 11;

   for(a = 0; logPaths_samba[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_samba[a]);
      }
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_samba[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* SNORT.ALERT */
   if(MyLog->verbose > 4){
      printf("[VERBOSE] Adding snort.alert logfiles\n");
   }
   MyLog->logtype = 12;

   for(a = 0; logPaths_snort_alert[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_snort_alert[a]);
      }
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_snort_alert[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }



   /* OTHERS */
   if(MyLog->verbose > 4){ 
      printf("[VERBOSE] Adding other logfiles\n");
   }
   MyLog->logtype = 7;

   for(a = 0; logPaths_other[a] != 0; a++) {
      if(MyLog->verbose > 5){
         printf(" %s, ", logPaths_other[a]);
      }
      memset(MyLog->name, 0, BUFF_LONG);
      strncpy(MyLog->name, logPaths_other[a], BUFF_LONG - 1);
      addLog(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
      printf(" \n");
   }
   /* TEXT */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding text logfiles\n");
   }
   MyLog->logtype = 1;
   
   for(a = 0; logDirs_text[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
	      printf(" %s, ", logDirs_text[a]);
	   }
      memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logDirs_text[a], BUFF_LONG - 1);
	   scanDirs(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   /* LOGFILES */
   if(MyLog->verbose > 4) {
	   printf("[VERBOSE] Adding normal logfiles\n");
   } 
   MyLog->logtype = 2;
   
   for(a = 0; logDirs_logs[a] != 0; a++) {
	   if(MyLog->verbose > 5) {
         printf(" %s, ", logDirs_logs[a]);
	   }
      memset(MyLog->name, 0, BUFF_LONG);
	   strncpy(MyLog->name, logDirs_logs[a], BUFF_LONG - 1);
	   scanDirs(mylog, MyLog);
   }
   if(MyLog->verbose > 5) {
	   printf(" \n");
   }
   
   return;
}
