#include "../include/config.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>

/* own */
#include <logcl.h>
#include <misc_listen.h>
#include <misc_add.h>
#include <defaults_add.h>
#include <defaults_syslog.h>
#include <help.h>
#include <make_clear.h>
#include <misc_dirs.h>
#include <easy.h>
/*#include "../Liblogclean/include/logclean.h" */
#include <logclean.h>

/* globals */
char *mytmpfile = 0;
int verbose = 2;  /* default: 2 
		     		for beta testing*/

/*	functions */
void sig_clean_up(int sig);
void clean_up(void);
void mybanner(void);


/* dummy banner */
void mybanner(void)
{
    puts("------------------------------------------------------------------");
    puts("                          Logcleaner-NG                           ");
    puts("                               ***                                ");
    puts("                                *                                 ");
    puts("------------------------------------------------------------------");
    return;
}

/* insecure file handling! */
void sig_clean_up(int sig)
{
   if (verbose > 4) {
	   printf("[STATUS] end wash \tCleaning my tmpfiles\n");
   }
   
   /*return;*/ /* For debugging only */
   
   if(access(mytmpfile, F_OK) == 0) {	/* file exits? */
	   if(wipe(mytmpfile, verbose) < 0) {
	      fprintf(stderr,
                 "[ERROR]  cannot wipe %s! Try someting else!\a\n", mytmpfile);
	   return;
	   }
   }
   free(mytmpfile);

   return;

}
/* at exit */
void clean_up(void)
{
   if(verbose > 4) {
	   printf("[STATUS] end wash \tCleaning my tmpfiles\n");
   }
   /* return;*/ /* For debugging only */
   
   if(access(mytmpfile, F_OK) == 0) {	/* file exits? */
	   if(wipe(mytmpfile, verbose) < 0) {
	      fprintf(stderr,
                 "[ERROR]  cannot wipe %s! Try someting else!\a\n", mytmpfile);
	   return;
	   }
   }
   free(mytmpfile);

   return;
}

/* main */
int main(int argc, char *argv[])
{
   int result;
   /*char   *tmpfile=0;*/
   /*int     verbose=4;*/
   int cleanDefaults = 0;
   int do_interactive = 0;
   char *mylogfile = 0;
   char *key = 0;

   char *logfile = 0;
   char *textfile = 0;
   char *otherlogfile = 0;
   char *modsecfile = 0;
   char *wtmpfile = 0;
   char *preludelogfile = 0;
   char *preludexmlfile =0;
   char *sambalogfile =0;
   char *snortalertfile =0;
   char *manualeditlogfile =0;
   char *lastlogfile = 0;
   char *acctfile = 0;
   char *wipefile = 0;
   char *touchfiles = 0;
   char *orgfile;
   char *changefile;

   char *string = 0;
   char *replace = 0;
   char *user = 0;
   char *host = 0;
   char *tty = 0;
   char *command = 0;
   char *timestring = 0;
   int coredumps = 0;

   
   time_t *temp = NULL;
   int i = 0;

   struct Cleanme mylog;
   block_head_t *loglist;
   block_t *cur;
   block_t *next;

   
   while(1) {
	   result = getopt(argc, argv, "hHAIv:f:k:s:r:t:l:w:L:a:u:i:T:c:U:C:D:R:o:m:p:P:S:b:M:");
	      if (result < 0) {
	         break;
         }
	      switch(result) {
	         case 'h':
	            help();
	            return 1;
	         break;
	         case 'H':
	            more_help();
               return 1;
	         break;
	         case 'v':
	            verbose = atoi(optarg);
	         break;
	         case 'A':
	            cleanDefaults = 1;
	         break;
	         case 'I':
	            do_interactive = 1;
	         break;
	         case 'f':
	            mylogfile = optarg;
	         break;
	         case 'k':
	            key = optarg;
	         break;
	         case 't':
	            textfile = optarg;
	         break;
            case 'o':
               otherlogfile = optarg;
            case 'm':
               modsecfile = optarg;
            break;
            case 'p':
               preludelogfile = optarg;
            break;
            case 'P':
               preludexmlfile = optarg;
            break;
            case 'S':
               sambalogfile = optarg;
            break;
            case 'b':
               snortalertfile = optarg;
            break;
            case 'M':
               manualeditlogfile = optarg;
            break;
	         case 'l':
	            logfile = optarg;
	         break;
	         case 'w':
	            wtmpfile = optarg;
	         break;
	         case 'L':
	            lastlogfile = optarg;
	         break;
	         case 'a':
	            acctfile = optarg;
	         break;
	         case 's':
	            string = optarg;
	         break;
	         case 'r':
	            replace = optarg;
	         break;
	         case 'u':
	            user = optarg;
	         break;
	         case 'i':
	            host = optarg;
	         break;
	         case 'U':
	            tty = optarg;
	         break;
	         case 'c':
	            command = optarg;
	         break;
	         case 'C':
	            coredumps = atoi(optarg);
	         break;
	         case 'T':
	            timestring = optarg;
	         break;
	         case 'D':
	            wipefile = optarg;
	         break;
	         case 'R':
	            touchfiles = optarg;
	         break;
	         default:
	            help();
   }
 }
   /* banner */
   mybanner();
   
   /* checking options */
   /*    checking for hAx0R$ */
   if(mylogfile) {
	   if((strlen(mylogfile)) > BUFF_SHORT - 1) {
	      fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(key) {
	   if((strlen(key)) > BUFF_SHORT - 1) {
	      fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n key is too long\n");
	      exit(23);
	   }
   }
   if(string) {
	   if((strlen(string)) > BUFF_SHORT - 1) {
         fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(replace) {
      if((strlen(replace)) > BUFF_SHORT - 1) {
	      fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(user) {
	   if((strlen(user)) > BUFF_SHORT - 1) {
	      fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(host) {
	   if((strlen(host)) > BUFF_SHORT - 1) {
         fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(command) {
	   if((strlen(command)) > BUFF_SHORT - 1) {
         fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   if(tty) {
	   if((strlen(tty)) > BUFF_SHORT - 1) {
	      fprintf(stderr,"[HAX0R] Trying to buffer0verflow a\
                 logcleaner is NOT usefull!\n");
	      exit(23);
	   }
   }
   
   /*   checking for usefull oprions */
   if(textfile) {
	   if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
	      return 42;
	   }
	   if(!replace) {
         fprintf(stderr, "[IDIOT] give a string to replace\n");
	      return 42;
	   }
   }
   if(logfile) {
	   if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
	      return 42;
	   }
   }
   if(otherlogfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(modsecfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(preludelogfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(preludexmlfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(sambalogfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(snortalertfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
   if(manualeditlogfile){
      if(!string) {
         fprintf(stderr, "[IDIOT] give a string to clean\n");
         return 42;
       }
   }
      
   if(wtmpfile) {
	   if((!string) && (!user) && (!host)) {
         fprintf(stderr, "[IDIOT] give something to clean\n");
	      return 42;
	   }
   }
   if(lastlogfile) {
	   if((!string) && (!user)) {
         fprintf(stderr, "[IDIOT] give something to clean\n");
	      return 42;
	   }
   }
   if(acctfile) {
	   if((!string) && (!user) && (!command) && (!tty) && (!coredumps)) {
         fprintf(stderr, "[IDIOT]  give something to clean\n");
	      return 42;
	   }
   }
   if((!textfile) &&
	   (!logfile) &&
	   (!otherlogfile) &&
      (!modsecfile) &&
      (!preludelogfile) &&
      (!preludexmlfile) &&
      (!sambalogfile) &&
      (!snortalertfile) &&
      (!manualeditlogfile) &&
	   (!wtmpfile) &&
	   (!lastlogfile) &&
	   (!acctfile) &&
	   (!wipefile) &&
	   (!touchfiles) && (cleanDefaults == 0) && (do_interactive == 0)) {
	      fprintf(stderr,"[IDIOT] WHAT do you want to do? mount /dev/brain!\n");
	      return 42;
   }
   
   /* make struct */
   memset(&mylog, 0, sizeof(struct Cleanme));
   
   /* create list */
   loglist = list_Create();
	
   /* fill structure */
   if(mylogfile) {
      strncpy(mylog.logto, mylogfile, BUFF_SHORT);
      mylog.logto[BUFF_SHORT - 1] = 0x0;
   }
   if(key) {
	   strncpy(mylog.crypt, key, BUFF_SHORT);
      mylog.crypt[BUFF_SHORT - 1] = 0x0;
   }
   if(string) {
	   strncpy(mylog.searchstring, string, BUFF_SHORT);
      mylog.searchstring[BUFF_SHORT - 1] = 0x0;  
   }
   if(replace) {
	   strncpy(mylog.replacestring, replace, BUFF_SHORT);
      mylog.replacestring[BUFF_SHORT - 1] = 0x0;
   }
   if(user) {
	   strncpy(mylog.user, user, BUFF_SHORT);
      mylog.user[BUFF_SHORT - 1] = 0x0;
   }
   if(host) {
	   strncpy(mylog.host, host, BUFF_SHORT);
      mylog.host[BUFF_SHORT - 1] = 0x0;
   }
   if(tty) {
	   strncpy(mylog.tty, tty, BUFF_SHORT);
      mylog.tty[BUFF_SHORT - 1] = 0x0;
   }
   if(command) {
	   strncpy(mylog.cmd, command, BUFF_SHORT);
      mylog.cmd[BUFF_SHORT - 1] = 0x0; 
   }
   mylog.clear_core = coredumps;
   mylog.verbose = verbose;
   
   if(timestring) {
	   temp = (time_t *)char2time(timestring);
	   memcpy(&(mylog.change_time), temp, sizeof(time_t));
	   /*mylog.change_time = temp; */
   }
   
   /* DEBUG */
   if(verbose > 8) {
      puts("[VERBOSE] structure ready");
   }
   if(textfile) {
      mylog.logtype = 1;
	   memset(mylog.name, 0, BUFF_LONG); /* */
	   strncpy(mylog.name, textfile, BUFF_LONG - 1);
	      if(checkdir(textfile) == 0) {
	         scanDirs(loglist, &mylog);
	      } else {
	         addLog(loglist, &mylog);
	      }
   }
   if(logfile) {
	   mylog.logtype = 2;
	   memset(mylog.name, 0, BUFF_LONG);
	   strncpy(mylog.name, logfile, BUFF_LONG - 1);
	      if(checkdir(logfile) == 0) {
	         scanDirs(loglist, &mylog);
	      } else {
	         memset(mylog.name, 0, BUFF_LONG); /*  */
	         strncpy(mylog.name, logfile, BUFF_LONG - 1);
	         addLog(loglist, &mylog);
	      }
   }
   if(otherlogfile) {
      mylog.logtype = 7;
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, logfile, BUFF_LONG - 1);
         if(checkdir(logfile) == 0) {
            scanDirs(loglist, &mylog);
         } else {
            memset(mylog.name, 0, BUFF_LONG); /*  */
            strncpy(mylog.name, logfile, BUFF_LONG - 1);
            addLog(loglist, &mylog);
         }
   }

   if(wtmpfile) {
	   memset(mylog.name, 0, BUFF_LONG);
	   strncpy(mylog.name, wtmpfile, BUFF_LONG - 1);
	   mylog.logtype = 3;
	   addLog(loglist, &mylog);
   }
   if(lastlogfile) {
	   memset(mylog.name, 0, BUFF_LONG);
	   strncpy(mylog.name, lastlogfile, BUFF_LONG - 1);
	   mylog.logtype = 5;
	   addLog(loglist, &mylog);
   }
   if(acctfile) {
	   memset(mylog.name, 0, BUFF_LONG);
	   strncpy(mylog.name, acctfile, BUFF_LONG - 1);
	   mylog.logtype = 6;
	   addLog(loglist, &mylog);
   }
   if(modsecfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, modsecfile, BUFF_LONG - 1);
      mylog.logtype = 8;
      addLog(loglist, &mylog);
   }
   if(preludelogfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, preludelogfile, BUFF_LONG - 1);
      mylog.logtype = 9;
      addLog(loglist, &mylog);
   }
   if(preludexmlfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, preludexmlfile, BUFF_LONG - 1);
      mylog.logtype = 10;
      addLog(loglist, &mylog);
   }
   if(sambalogfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, sambalogfile, BUFF_LONG - 1);
      mylog.logtype = 11;
      addLog(loglist, &mylog);
   }
   if(snortalertfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, snortalertfile, BUFF_LONG - 1);
      mylog.logtype = 12;
      addLog(loglist, &mylog);
   }
   if(manualeditlogfile) {
      memset(mylog.name, 0, BUFF_LONG);
      strncpy(mylog.name, manualeditlogfile, BUFF_LONG - 1);
      mylog.logtype = 13;
      addLog(loglist, &mylog);
   }

   if(cleanDefaults == 1) {
	   add_default_logs(loglist, &mylog);
	   add_syslogs(loglist, &mylog);
   }
   if(wipefile) {
	   if(wipe(wipefile, verbose) < 0) {
         fprintf(stderr,"[ERROR]  cannot wipe %s! Try someting else!\n",
                 wipefile);
	   }
   }
   if(touchfiles) {
	   orgfile = strtok(touchfiles, ",");
	   changefile = strtok(0, ",");
	   if(touch3(orgfile, changefile) < 0) {
	      fprintf(stderr, "[ERROR] cannot change MAC Time of %s!\
                 Try someting else!\n", orgfile);
	   }
   }
   if(do_interactive == 1) {
	   interactive(loglist);
   }
   
   /* better allways to remove tmpfiles ;-) */
   if(atexit(clean_up) != 0) {
	   fprintf(stderr, "[ERROR] \tin cleaning up\n[WARN]\a\t\
              Clean up you files!!!\n");
   }
   /* be paranoid */
   signal(SIGINT, sig_clean_up); 
   signal(SIGTERM, sig_clean_up); 
   signal(SIGHUP, sig_clean_up); 

   /* tmp file */
   /* Create temp file names
    * YES tempnam is unsecure!
    */
   if((mytmpfile = tempnam(".", "_mutt_XXXXXX")) == 0) {
	   fprintf(stderr, "[ERROR] tempnam(mytmpfile) failed!\n");
	   return -3;
   }
   
   /* DEBUG */
   if(verbose > 8) {
      puts("[VERBOSE] tmp file created");
   }
   
   cur = loglist->head;
   while(cur) {
      next = cur->next;
      clear_log(cur->Log, mytmpfile);
         if(verbose > 8) {
	         printf("--------------------- DEBUG -----------------------\n");
	         printf("===================================================\n");
	         printf("[X] Name:%s \n", cur->Log->name);
	         printf("[X] search:%s \n", cur->Log->searchstring);
	         printf("[X] raplace:%s \n", cur->Log->replacestring);
	         printf("[X] user:%s \n", cur->Log->user);
	         printf("[X] tty:%s \n", cur->Log->tty);
	         printf("[X] cmd:%s \n", cur->Log->cmd);
	         printf("[X] logto:%s \n", cur->Log->logto);
	         printf("[X] crypt:%s \n", cur->Log->crypt);
	         printf("[X] logtype:%d \n", cur->Log->logtype);
	         printf("[X] compressed:%d \n", cur->Log->compressed);
	         printf("[X] verbose:%d \n", cur->Log->verbose);
	         printf("[X] is_clean:%d \n", cur->Log->is_clean);
	         printf("[X] checked:%d \n", cur->Log->checked);
	         printf("[X] was_clean:%d \n", cur->Log->was_clean);
	         printf("[X] ignore:%d \n", cur->Log->ignore);
	         printf("[X] Time=%s", ctime(temp));
	         printf("===================================================\n");
	      }
	      i++;
         cur = cur->next;
   }
   
   /* check lenght of loglist */
   if(verbose > 8) {
	   i = listLeng(loglist);
	   printf("Number of logs in Loglist: %d\n", i);
   }
   
   /* delete loglist again */
   listDelete(loglist);

   /* do NOT leave tmpfiles! */
   /* if(access(mytmpfile,F_OK)==0){ 
         if (wipe(mytmpfile, verbose) <0) {
         fprintf(stderr, "[ERROR]  cannot wipe %s!\
                  Try someting else!\a\n",mytmpfile);
         return -1;
         }
      }
    */
   return 0;
}
