#include <stdio.h>
#include <stdlib.h>

/* own */
#include <logcl.h>
#include <misc_listen.h>

block_head_t *list_Create(void)
{
   block_head_t *head = (block_head_t *) malloc(sizeof(block_head_t));
   if(head) {
	   head->head = head->tail = 0;
	   return(head);
   }
   return 0;
}

int listAppend(block_head_t * head)
{
   block_t *ap = (block_t *) calloc(1, sizeof(block_t));
   struct Cleanme *new_block =
      (struct Cleanme *)calloc(1, sizeof(struct Cleanme));

   if((ap) && (new_block)) {
	   ap->Log = new_block;
	   ap->next = 0;

	if(!(head->head)) {
      /* list empty */
	   head->head = ap;
	   head->tail = ap;
	   ap->prev = head->head;
	   ap->next = 0;
	   return 1;
	} else {
      ap->prev = head->tail;
	   ap->next = 0;
	   head->tail->next = ap;
	   head->tail = ap;
	   return 1;
	}
   } else {
	   fprintf(stderr, "[ERROR] malloc...\n");
	   if(ap) {
	      free(ap);
	      ap = 0;
	   }
	   if(new_block) {
	      free(new_block);
	      new_block = 0;
	   }
	   return 0;
   }
}
int listDelete(block_head_t * head)
{
   block_t *cur = head->head;
   block_t *next;
   
   while(cur) {
	   next = cur->next;
	   free(cur->Log);
	   free(cur);
	   cur = next;
   }
   head->head = 0;
   head->tail = 0;
   free(head);
   
   return 1;
}

int listLeng(block_head_t * head)
{
   int leng = 0;
   block_t *cur = head->head;
   block_t *next;
   while(cur) {
	   next = cur->next;
	   leng++;
	   cur = next;
   }
   return leng;
}
